package com.spectus.iap.spectus_in_app_purchase

import androidx.annotation.NonNull

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** SpectusInAppPurchasePlugin */
class SpectusInAppPurchasePlugin: FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private lateinit var channel : MethodChannel

  var productID : String = ""

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    channel = MethodChannel(flutterPluginBinding.binaryMessenger, "spectus_in_app_purchase")
    channel.setMethodCallHandler(this)
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    } else if (call.method == "startInAppPurchaseWith") {
      Log.e("Method Called","startInAppPurchaseWith")
      productID = call.argument<String?>("productID")

      IAPHelper().startInAppPurchaseWith(context, productID, { error, purchaseObject, transactionID ->
        if (error != null) {
          Log.d("ERROR ----> " , error)
          result("NA")
        }

        if (transactionID != null) {
          Log.e("TRANSACTION ID -----> " , transactionID)
          result(transactionID)
        }
      })
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    channel.setMethodCallHandler(null)
  }
}
